class_name BuildingOption
extends Control


signal selected(item: BuildingOptionItem)

@export var selected_id: int

const buildings_json = preload("res://src/modules/building/building_option/buildings.tres")

var option_button: OptionButton;

var selected_option: BuildingOptionItem = null
var options: Array[BuildingOptionItem] = []

func _select_option_by_id(building_id):
	for option in options:
		if option.id == building_id:
			selected_id = building_id
			selected_option = option
			selected.emit(option)
			break

func select(building_id: int):
	option_button.selected = option_button.get_item_index(building_id)
	_select_option_by_id(building_id)

func _enter_tree():
	option_button = $OptionButton;
	
	for building_group in buildings_json.data:
		option_button.add_separator(building_group.group)
		
		for building in building_group.children:
			options.append(BuildingOptionItem.new(building))
			option_button.add_item("{label} ({energy} ⚡)".format(building), building.id)


func _ready():
	if selected_id != null:
		select(selected_id)


func _on_option_button_item_selected(index):
	var building_id = option_button.get_item_id(index)
	_select_option_by_id(building_id)
