class_name EnergySection
extends MarginContainer

signal changed()
signal deleted(section_node: Node)

@export var title: String
@export var title_placeholder: String
@export var rows_data: Array[EnergyTableRowData]

var table: EnergyTable


func _enter_tree():
	table = $HBoxContainer/EnergyTable
	table.title = title
	table.title_placeholder = title_placeholder
	table.rows_data = rows_data


func _ready():
	pass


func _on_delete_section_button_pressed():
	deleted.emit(self)


func get_save_data() -> Dictionary:
	return table.get_save_data()


func _on_energy_table_changed():
	changed.emit()
