class_name EnergyTableRow
extends HBoxContainer


signal deleted(instance: Node)
signal total_energy_changed(new_value: int)


@export var building_id: int
@export var building_count: int = 1

var total_energy_label: Label
var building_option: BuildingOption
var building_count_line_edit: LineEdit

var building: BuildingOptionItem
var total_energy: int:
	get:
		return total_energy
	set(value):
		if value != total_energy:
			total_energy = value
			total_energy_changed.emit(value)
			total_energy_label.text = str(total_energy)



func render_energy():
	total_energy = building_count * (building.energy if building else 0)

func _enter_tree():
	total_energy_label = $HBoxContainer/EnergyLabel
	building_option = $BuildingOption
	if building_id != null:
		building_option.selected_id = building_id
	building_count_line_edit = $BuildingCountLineEdit
	building_count_line_edit.text = str(building_count)
	

func _ready():
	render_energy()

func _on_unit_count_line_edit_text_changed(new_text):
	building_count = int(new_text)
	render_energy()

func _on_delete_row_button_pressed():
	deleted.emit(self)


func _on_building_option_selected(item: BuildingOptionItem):
	building = item
	render_energy()

func get_save_data() -> Dictionary:
	var data = {
		"building_count": building_count,
	}
	if building != null:
		data["building_id"] = building.id
	return data
